/////////  Wieze Stereo   ////////


#include <iostream.h>
#include <string.h>


////////////////////////////



class Odtwarzacz
{
	char Polozenie[32];

public:
	
	char* DajPolozenie()
	{
		return Polozenie;
	}


	friend ostream& operator << (ostream& wyj, Odtwarzacz& od);
	friend istream& operator >> (istream& wej, Odtwarzacz& od);
};


ostream& operator << (ostream& wyj, Odtwarzacz& od)
{
	wyj << "Polozenie odtwarzacza CD to " << od.Polozenie << endl;
	return wyj;
}

istream& operator >> (istream& wej, Odtwarzacz& od)
{
	char Bufor[128];
	cout << "Podaj polozenie odtwarzacza CD : ";
	wej >> Bufor;
	strncpy(od.Polozenie, Bufor, 31);

	return wej;
}
	

//////////////////////////////////


class Magnetofon
{
	int Napedy;

public:

	int DajNapedy()
	{
		return Napedy;
	}

	
	friend ostream& operator << (ostream& wyj, Magnetofon& mg);
	friend istream& operator >> (istream& wej, Magnetofon& mg);


};

ostream& operator << (ostream& wyj, Magnetofon& mg)
{
	if (mg.Napedy == 0)
		wyj << "Wieza bez magnetofonu. " << endl;
	else
	{
		wyj << "Magnetofon ma " << mg.Napedy;
		switch (mg.Napedy)
		{
		case 1 : wyj << " naped. " << endl;
				 break;
		case 2 : wyj << " napedy. " << endl;
		}
	}
	return wyj;
}


istream& operator >> (istream& wej, Magnetofon& mg)
{
	cout << "Podaj liczbe napedow magnetofonu : ";
	wej >> mg.Napedy;
	
	if( mg.Napedy < 0 || mg.Napedy > 2 )
		mg.Napedy = 0;
	
	return wej;
}


///////////////////////


class Odbiornik
{
	int Zakresy;

public:

	int DajZakresy()
	{
		return Zakresy;
	}

	friend ostream& operator << (ostream& wyj, Odbiornik& od);
	friend istream& operator >> (istream& wej, Odbiornik& od);

};


ostream& operator << (ostream& wyj, Odbiornik& od)
{
	wyj << "Liczba zakresow odbiornika : " << od.Zakresy << endl;
	return wyj;
}

istream& operator >> (istream& wej, Odbiornik& od)
{
	cout << "Podaj liczbe zakresow odbiornika : ";
	wej >> od.Zakresy;

	if ( od.Zakresy < 0 && od.Zakresy > 10)
		od.Zakresy = 0;

	return wej;
}


/////////////////////


class Wzmacniacz
{
	double Moc;			// [W]


public:

	double DajMoc()
	{
		return Moc;
	}


	friend ostream& operator << (ostream& wyj, Wzmacniacz& wm);
	friend istream& operator >> (istream& wej, Wzmacniacz& wm);


};



ostream& operator << (ostream& wyj, Wzmacniacz& wm)
{

	if (wm.Moc == 0)
		wyj << "Moc wzmacniacza nie znana." << endl;
	else
		wyj << "Moc wzmacniacza wynosi " << wm.Moc << " W" << endl;
	return wyj;
}

istream& operator >> (istream& wej, Wzmacniacz& wm)
{
	cout << "Podaj moc wzmacniacza [W] : ";
	wej >> wm.Moc;

	if ( wm.Moc < 0 || wm.Moc > 10000 )
		wm.Moc = 0;
	return wej;
}


////////////////////////


class Wieza
{
	Odtwarzacz CD;
	Magnetofon MT;
	Odbiornik  RD;
	Wzmacniacz WM;

public:

	Wieza()
	{}

	friend ostream& operator << (ostream& wyj, Wieza& wi);
	friend istream& operator >> (istream& wej, Wieza& wi);

};

ostream& operator << (ostream& wyj, Wieza& wi)
{
	wyj << wi.CD << wi.MT << wi.RD << wi.WM << endl;
	return wyj;
}

istream& operator >> (istream& wej, Wieza& wi)
{
	wej >> wi.CD >> wi.MT >> wi.RD >> wi.WM;
	return wej;
}


///////////////////////


void main()
{

	Wieza Ewidencja [100];

	int i, puste = 0;

	bool dalej = true;
	char pol;

	while (dalej)
	{
		cout << endl << "Podaj polecenie [N, W, K] : ";
		cin >> pol;

		switch (pol & 0x5F)
		{
		case 'N' : if (puste == 100)
				  	   cout << "Brak miejsca w tabeli." << endl;
				   else
				   {
					   cout << endl;
					   cin >> Ewidencja[puste++];	
				   }
				   
				   break;

		case 'W' : cout << endl;
			       for (i = 0; i < puste; i++)
					   cout << Ewidencja[i];
				   
			       break;
		
		case 'K' : dalej = 0;
		}	   
	}		
	cout << endl;

}
