///////  Deser  ////////


#include <iostream.h>
#include <string.h>

class Deser
{
protected:
	double Cena;
public:
	double DajCene()
	{
		return Cena;
	}

};

class Lody :public Deser
{

	char Smak[64];
	bool Bakalie;

	friend istream& operator >> (istream& wej, Lody& lody);
	friend ostream& operator << (ostream& wyj, Lody& lody);
};


istream& operator >> (istream& wej, Lody& lody)
{
	int jakie = -1;
	char bak;
	char* Smaki[4] =
	{"Smietankowe", "Kawowe", "Waniliowe", "Zabajone"};
		
	while (jakie < 1 || jakie > 4)
	{
		cout << "Jaki smak lodow Panstwo wybieraja? " << endl;
		cout << "1 - Smietankowe, 2 - Waniliowe," << endl;
		cout << "3 - Kawowe, 4 - Zabajone : ";
		wej >> jakie;
	}
	
	strcpy(lody.Smak, Smaki[jakie - 1]);

	cout << "Czy lody maja byc z bakaliami? [T/N] : ";
	wej >> bak;
	if ((bak & 0x5F) == 'T') 
		lody.Bakalie = true;
	else 
		lody.Bakalie = false;

	if (jakie < 3)
		lody.Cena = 4.5;
	else
		lody.Cena = 5.5;

	if (lody.Bakalie)
		lody.Cena += 1.0;

	return wej;
}

ostream& operator << (ostream& wyj, Lody& lody)
{
	wyj << endl << "Prosze podac lody : " << endl;
	wyj << "Smak " << lody.Smak;
	if (lody.Bakalie)
		wyj << " z bakaliami";
	wyj << endl << "Skasowac " << lody.Cena << " zl" << endl;
	return wyj;
}


class Ciasta : public Deser
{
protected:
	bool NaWage;
public:
	bool Wazymy()
	{
		return NaWage;
	}
};

class Tortowe : public Ciasta
{
	char RodzajKremu[16];

	friend istream& operator >> (istream& wej, Tortowe& tort);
	friend ostream& operator << (ostream& wyj, Tortowe& tort);
};


istream& operator >> (istream& wej, Tortowe& tort)
{
	int jakie = -1;
	char* Torty[3] =
	{"Czekoladowy", "Kawowy", "Migdalowy"};
		
	while (jakie < 1 || jakie > 3)
	{
		cout << "Jaki tort Panstwo wybieraja? " << endl;
		cout << "1 - Czekoladowy, 2 - Kawowy, 3 - Migdalowy : ";
		wej >> jakie;
	}
	
	strcpy(tort.RodzajKremu, Torty[jakie - 1]);

	tort.NaWage = true;

	if (jakie < 3)
		tort.Cena = 27.5;
	else
		tort.Cena = 35.5;

	
	return wej;
}

ostream& operator << (ostream& wyj, Tortowe& tort)
{
	wyj << endl << "Prosze podac ciastko tortowe z kremem ";
	wyj << tort.RodzajKremu << endl;
	if (tort.NaWage)
		wyj << "Skasowac wg wagi, cena 1 kg " << tort.Cena << " zl" << endl;
	else
		wyj << endl << "Skasowac " << tort.Cena << " zl" << endl;
	return wyj;
}

class Pieczywo : public Ciasta
{
	char RodzajPieczywa[32];

friend istream& operator >> (istream& wej, Pieczywo& kuch);
friend ostream& operator << (ostream& wyj, Pieczywo& kuch);
};

istream& operator >> (istream& wej, Pieczywo& kuch)
{
	int jakie = -1;
	char* Placki[3] =
	{"Rogal", "Drozdzowka", "Babka"};
		
	while (jakie < 1 || jakie >> 3)
	{
		cout << "Jakie ciastko Panstwo wybieraja? " << endl;
		cout << "1 - Rogal, 2 - Drozdzowka, 3 - Babka : ";
		wej >> jakie;
	}
	
	strcpy(kuch.RodzajPieczywa, Placki[jakie - 1]);

	if (jakie == 3)
		kuch.NaWage = true;
	else
		kuch.NaWage = false;


	if (jakie < 3)
		kuch.Cena = 4.5;
	else
		kuch.Cena = 9.5;

	
	return wej;
}

ostream& operator << (ostream& wyj, Pieczywo& kuch)
{
	wyj << endl << "Prosze podac ciastko : ";
	wyj << kuch.RodzajPieczywa << endl;
	if (kuch.NaWage)
		wyj << "Skasowac wg wagi, cena 1 kg " << kuch.Cena << " zl" << endl;
	else
		wyj << endl << "Skasowac " << kuch.Cena << " zl" << endl;
	return wyj;
}

void Zmiana()
{
	 cout << endl << "Skieruj gosci do stolika." << endl;
	 cout << "Zawolaj kelnerke i przygotuj deser." << endl;

}


void main()
{
	int jaki;
	char jest;
	bool KoniecPracy = false, waga;
	double Utarg = 0, cena;

	Lody* lody;
	Tortowe* tort;
	Pieczywo *kuch;

	while (!KoniecPracy)
	{
		// przy komputerze jest bufetowa
		jaki = -1;
		while (jaki < 1 || jaki > 3)
		{
			cout << endl << "Zapytaj o rodzaj deseru !" << endl << endl;

			cout << "Wprowadz wybrany rodzaj deseru : " << endl;
			cout << "1 - lody, 2 - tort, 3 - ciasto : ";
			cin >> jaki;
			if (jaki < 1 || jaki > 3)
				cout << "Wprowadz jeszcze raz" << endl;
		}
		
		cout << endl;

		switch (jaki)
		{
		case 1 : 
				 lody = new Lody;

				 cin >> *lody;
				 Zmiana();
				 cout << *lody;

				 waga = false;
				 Utarg += lody->DajCene();
				 delete lody;
				 break;
		case 2 : 
				 tort = new Tortowe;
				 cin >> *tort;
				 Zmiana();
				 cout << *tort;
				 if (!(waga = tort->Wazymy()))
					Utarg += tort->DajCene();
				 delete tort;
				 break;
		case 3 : 
				 kuch = new Pieczywo;
				 cin >> *kuch;
				 Zmiana();
				 cout << *kuch;
				 if (!(waga = kuch->Wazymy()))
					Utarg += kuch->DajCene();
				 delete kuch;
				 break;
		}
			 //  teraz do komputera podchodzi kelnerka
		
		if (waga)
		{
			cout << endl << "Wprowadz wartosc ciasta : ";
			cin >> cena;
			Utarg += cena;
		}

		jest = 'N';
		while ((jest & 0x5F) != 'T')
		{
			 cout << endl << "Jesli deser zostal podany " 
				     "i klienci zaplacili nacisnij \"T\" ";
			 cin >> jest;
		}
		cout  << endl << "Jesli koniec pracy nacisnij \"T\" : ";
		cin >> jest;
		if ((jest & 0x5F) == 'T')
		{
			KoniecPracy = true;
			cout << endl << "Dzisiejszy utarg to " << Utarg << " zl";
			cout << endl << endl;
		}
	}
}






	 